/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.thoughtworks.xstream.XStream
 *  com.thoughtworks.xstream.io.HierarchicalStreamDriver
 *  com.thoughtworks.xstream.io.xml.DomDriver
 *  fire.msp.npc.MNpcMoveTimerControl
 *  fire.pb.npc.NpcAI.NpcAITimer
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneClient
 *  fire.pb.scene.SceneManager
 *  fire.pb.scene.manager.SceneNpcManager
 *  fire.pb.scene.movable.NPC
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.scene.sPos.Position
 *  mkio.Protocol
 */
package fire.pb.scene.npcai;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.io.HierarchicalStreamDriver;
import com.thoughtworks.xstream.io.xml.DomDriver;
import fire.msp.npc.MNpcMoveTimerControl;
import fire.pb.npc.NpcAI.NpcAITimer;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneClient;
import fire.pb.scene.SceneManager;
import fire.pb.scene.manager.SceneNpcManager;
import fire.pb.scene.movable.NPC;
import fire.pb.scene.npcai.AIConfig;
import fire.pb.scene.npcai.AIConfigList;
import fire.pb.scene.npcai.Config_moveto;
import fire.pb.scene.npcai.NPCAI;
import fire.pb.scene.sPos.GridPos;
import fire.pb.scene.sPos.Position;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import mkio.Protocol;

public class AIManager {
    private static AIManager instance;
    private final Map<Long, NPCAI> npcais = new HashMap<Long, NPCAI>();
    private final Map<Integer, AIConfig> config = new HashMap<Integer, AIConfig>();

    public void loadConfig() {
        XStream stream = new XStream((HierarchicalStreamDriver)new DomDriver());
        try {
            Scene.LOG.info((Object)"load npc walk ai info start");
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(this.getLoadFileName())));
            stream.alias("data", AIConfigList.class);
            stream.alias("item", AIConfig.class);
            stream.addImplicitCollection(AIConfig.class, "configs");
            stream.addImplicitCollection(AIConfigList.class, "ais");
            stream.useAttributeFor("id", Integer.TYPE);
            stream.alias("moveto", Config_moveto.class);
            stream.useAttributeFor("x", Integer.TYPE);
            stream.useAttributeFor("y", Integer.TYPE);
            stream.useAttributeFor("speed", Integer.TYPE);
            AIConfigList result = (AIConfigList)stream.fromXML((Reader)reader);
            this.config.clear();
            for (AIConfig conf : result.getAis()) {
                this.config.put(conf.getAID(), conf);
            }
            Scene.LOG.info((Object)"load npc walk ai info end");
        }
        catch (FileNotFoundException e) {
            Scene.LOG.info((Object)("从" + this.getLoadFileName() + "加载ai信息失败"));
        }
    }

    public void summonTest() {
        int npcid = 10779;
        Scene s = SceneManager.getInstance().getSceneByID(1007L);
        if (null == s) {
            return;
        }
        Position p = new GridPos(360, 270).toPosition();
        NPC n = SceneNpcManager.getInstance().createNpc(10779, "testAI", 5);
        n.setName(n.getName() + n.getNpcKey());
        SceneNpcManager.getInstance().summonNpcAndUpdateGS(s, p, n);
    }

    public void npcMoveByAiID(long npcKey, int aid, Set<Long> roleids) {
        NPC n = SceneNpcManager.getInstance().getNpcByKey(Long.valueOf(npcKey));
        if (null == n) {
            return;
        }
        n.setRelative(roleids);
        AIConfig ac = this.config.get(aid);
        if (null == ac) {
            return;
        }
        NPCAI na = new NPCAI(n, ac);
        na.start();
        this.addNewAi(na);
    }

    public String getLoadFileName() {
        return "gamedata/xml/ai.xml";
    }

    public void process(long tick) {
        HashSet<Long> del = new HashSet<Long>();
        for (NPCAI n : this.npcais.values()) {
            if (n.checkOver()) {
                del.add(n.getNpcKey());
                continue;
            }
            n.exec(tick);
        }
        Iterator<NPCAI> iterator = del.iterator();
        while (iterator.hasNext()) {
            long l = (Long)((Object)iterator.next());
            this.npcais.remove(l);
        }
        if (this.npcais.isEmpty()) {
            NpcAITimer.getInstance().end();
        }
    }

    private void addNewAi(NPCAI ai) {
        this.npcais.put(ai.getNpcKey(), ai);
        if (this.npcais.size() == 1) {
            SceneClient.pSend((Protocol)new MNpcMoveTimerControl(1));
        }
    }

    public static synchronized AIManager getInstance() {
        if (null == instance && null == instance) {
            instance = new AIManager();
        }
        return instance;
    }

    private AIManager() {
    }
}

